/*
      CCI_DB_v.1.1       -     
      CCI_DB_v.1.4        
*/
#property copyright ""
#property link      ""
#property version   "1.4"
#property strict
#property indicator_chart_window
#property description "DashBoard.    CCI     ."


enum sel_tf 
{
    NO  = 0,
    M1  = PERIOD_M1,
    M5  = PERIOD_M5,
    M15 = PERIOD_M15,
    M30 = PERIOD_M30,
    H1  = PERIOD_H1,
    H4  = PERIOD_H4,
    D1  = PERIOD_D1,
    W1  = PERIOD_W1,
    MN1 = PERIOD_MN1,
    
};
extern int           ROWS        = 3;      //   ( CCI   ) 
extern int           COLUMNS     = 5;      //   ()
extern string t1 = "   1 ";
extern sel_tf        TF1_V       = M1;     //  
extern int           TF1_P1      = 8;      //  CCI 1
extern int           TF1_P2      = 14;     //  CCI 2
extern int           TF1_P3      = 42;     //  CCI 3
extern double        TF1_Level   = 100;    // 
extern string t2 = "   2 ";
extern sel_tf        TF2_V       = M5;     //  
extern int           TF2_P1      = 8;      //  CCI 1
extern int           TF2_P2      = 14;     //  CCI 2
extern int           TF2_P3      = 42;     //  CCI 3
extern double        TF2_Level   = 100;    // 
extern string t3 = "   3 ";
extern sel_tf        TF3_V       = M15;    //  
extern int           TF3_P1      = 8;      //  CCI 1
extern int           TF3_P2      = 14;     //  CCI 2
extern int           TF3_P3      = 42;     //  CCI 3
extern double        TF3_Level   = 100;    // 
extern string t4 = "   4 ";
extern sel_tf        TF4_V       = H1;     //  
extern int           TF4_P1      = 8;      //  CCI 1
extern int           TF4_P2      = 14;     //  CCI 2
extern int           TF4_P3      = 42;     //  CCI 3
extern double        TF4_Level   = 100;    // 
extern string t5 = "   5 ";
extern sel_tf        TF5_V       = H4;     //  
extern int           TF5_P1      = 8;      //  CCI 1
extern int           TF5_P2      = 14;     //  CCI 2
extern int           TF5_P3      = 42;     //  CCI 3
extern double        TF5_Level   = 100;    // 
extern string t6 = "    -";
extern ENUM_BASE_CORNER     Corner      = CORNER_RIGHT_UPPER;      //    
extern int           X           = 20;     //  X
extern int           Y           = 20;     //  Y
struct CCI_param 
{
    
    double  val_1[2];  //       - 0  1
    double  val_2[2];
    double  val_3[2];
    int     period[3];
    sel_tf  timeFrame;
    double  level;
};


CCI_param CCI[5];

int gridStepX  = 40;
int gridStepY  = 30;
int BaseX;  //      
int BaseY;
int TableH, TableW;

string   MyName      = "CCI_DB_";
string   Font        = "Arial";
int      FontSize    = 8;
color    FontColor   = Black;
string   RowH[]      = {"P1", "P2", "P3"};
sel_tf   TfArray[5];
int      ArrSize     = 5;
int      PicSize     =22;     //    
int      RowsCCI;             // -   
string   shortname;

//==================================================================
//    OnInit
//==================================================================
int OnInit()
{  
  if(ROWS < 1) ROWS = 3;
  if(ROWS > 3) ROWS = 3;
  if(COLUMNS < 1) COLUMNS = 5; 
  if(COLUMNS > 5) COLUMNS = 5;
   BaseX = X;
   BaseY = Y;
   shortname = MyName  + Symbol() + "_" + IntegerToString(Period());
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
   int sz;
   
   sz = InitCCIArray();
   sz = MathMin(sz, COLUMNS);
   ArrSize = sz;
   ArrayResize(CCI, ArrSize);
   
   DelMyObj(MyName);
   RowsCCI = ROWS;
   //X = ArrSize*gridStepX + 80;
   
   TableH = (RowsCCI+1)*gridStepY;                  //    
   TableW = (ArrSize +1)*gridStepX;       //    
   ChartForegroundSet(false,0);
   return(INIT_SUCCEEDED);
}
//==================================================================
//    deinit
//==================================================================
int  deinit()
{
   DelMyObj(MyName);
   return(0);
}
//==================================================================
//    ChartForegroundSet
//==================================================================
bool ChartForegroundSet(const bool value,const long chart_ID=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetInteger(chart_ID,CHART_FOREGROUND,0,value))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
 
//==================================================================
//    OnCalculate
//==================================================================
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{

   if(ArrSize == 0 || RowsCCI == 0) //    
   {
      DelMyObj(MyName);
      return(0);
   }
   CreateFrame();
   CreateHeaders(BaseX,BaseY);
   GetInds();
   Arrows();

   return(rates_total);
}
//==================================================================
//    CreateFrame
//==================================================================
void CreateFrame()
{
                      long             chart_ID=0;               // ID 
                      string           name="RectLabel";         //  
                      int              sub_window=0;             //  
                      int              x=0;                      //    X
                      int              y=0;                      //    Y
                      int              width=50;                 // 
                      int              height=18;                // 
                      color            back_clr=C'236,233,216';  //  
                      //ENUM_BORDER_TYPE border=BORDER_SUNKEN;     //  
                      ENUM_BORDER_TYPE border=BORDER_FLAT;     //  
                      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; //    
                      color            clr = clrDimGray;               //    (Flat)
                      ENUM_LINE_STYLE  style=STYLE_SOLID;        //   
                      int              line_width=1;             //   
                      bool             back = false;               //   
                      bool             selection=false;          //   
                      bool             hidden=true;              //    
                      long             z_order=0;                //    
      
      corner = Corner;
      string InpName = MyName + "Frame";
      if(corner == CORNER_LEFT_UPPER)     { x = BaseX;           y = BaseY;}
      if(corner == CORNER_RIGHT_UPPER)    { x = BaseX + TableW;  y = BaseY;}
      if(corner == CORNER_LEFT_LOWER)     { x = BaseX ;          y = BaseY + TableH;}
      if(corner == CORNER_RIGHT_LOWER)    { x = BaseX + TableW;  y = BaseY + TableH;}
      width  = TableW;
      height = TableH;
      color InpBackColor = White;
      ENUM_BORDER_TYPE InpBorder = border;
      ENUM_BASE_CORNER InpCorner = corner;
      color InpColor = clr;
      ENUM_LINE_STYLE InpStyle = style;
      int  InpLineWidth = line_width;
      bool InpBack = back;
      bool InpSelection = selection;
      bool InpHidden = false;
      long InpZOrder = z_order;
      
      ObjectDelete(InpName);
      RectLabelCreate(0,InpName,0,x,y,width,height,InpBackColor,InpBorder,InpCorner,
      InpColor,InpStyle,InpLineWidth,InpBack,InpSelection,InpHidden,InpZOrder);
}


//==================================================================
//    Arrows
//==================================================================
void Arrows()
{
    int i;
    double  val1_0,  //  cci   
            val1_1,  //  cci    
            val2_0, val2_1, val3_0,val3_1;
    double level;
    int code1 = 0, code2 = 0, code3 = 0;        
    string tt1 = "", tt2="",tt3="";
      for(i=0; i<ArrSize; i++)    //   
      {
              level = CCI[i].level;
              
              val1_0 = CCI[i].val_1[0];     
              val1_1 = CCI[i].val_1[1];
              
              val2_0 = CCI[i].val_2[0];   
              val2_1 = CCI[i].val_2[1];
              
              val3_0 = CCI[i].val_3[0];   
              val3_1 = CCI[i].val_3[1];
              
              //-----------------------------   CCI    (8)----------------------------------------
              
              if(val1_0 < 0      && val1_0 > -level && val1_1 <= -level )        code1 = 1;  //       
              if(val1_0 > 0      && val1_0 <  level && val1_1 <= 0 )             code1 = 2;  //            
              if(val1_0 > level  && val1_1 <= level )                            code1 = 3;  //      
              if(val1_0 > level  && val1_1 >  level )                            code1 = 4;  // 
              if(val1_0 < level  && val1_1 >= level )                            code1 = 5;  //      
              if(val1_0 < 0      && val1_1 >= 0 && val1_0 > - level)             code1 = 6;  //            
              if(val1_0 < -level && val1_1 >= -level )                           code1 = 7;  //       
              if(val1_0 < -level && val1_1 <= -level )                           code1 = 8;  //       
              if(val1_0 < level && val1_1 < level && val1_0 > 0 && val1_1 > 0)         code1 = 9;  //    
              if(val1_0 > -level && val1_1 > -level && val1_0 <= 0 && val1_1 <= 0)     code1 = 10; //    
              
              tt1 = " " + TfToString(CCI[i].timeFrame) + " CCI_1(" + IntegerToString(CCI[i].period[0]) + ")= " + DoubleToString(val1_0, 1) 
              + "\n" + CodeToText(code1, level);
              DrawArrow(i, 1, code1, tt1);  //  CCI
              
              
              if(RowsCCI >= 2)
              {
              //-----------------------------   CCI    (14)----------------------------------------
              //code = 0;
              if(val2_0 < 0      && val2_0 > -level && val2_1 <= -level )        code2 = 1;  //       
              if(val2_0 > 0      && val2_0 <  level && val2_1 <= 0 )             code2 = 2;  //            
              if(val2_0 > level  && val2_1 <= level )                            code2 = 3;  //      
              if(val2_0 > level  && val2_1 >  level )                            code2 = 4;  // 
              if(val2_0 < level  && val2_1 >= level )                            code2 = 5;  //      
              if(val2_0 < 0      && val2_1 >= 0 && val2_0 > - level)             code2 = 6;  //            
              if(val2_0 < -level && val2_1 >= -level )                           code2 = 7;  //       
              if(val2_0 < -level && val2_1 <= -level )                           code2 = 8;  //       
              //if(code == 0) code = 1; // 
              if(val2_0 < level && val2_1 < level && val2_0 > 0 && val2_1 > 0)         code2 = 9;  //    
              if(val2_0 > -level && val2_1 > -level && val2_0 <= 0 && val2_1 <= 0)     code2 = 10; //    
              

              tt2 = " " + TfToString(CCI[i].timeFrame)  + " CCI_2(" + IntegerToString(CCI[i].period[1]) + ")= " +  DoubleToString(val2_0, 1) 
              + "\n" + CodeToText(code2, level);;
              DrawArrow(i, 2, code2, tt2);                                                        //  CCI
              }
              
              if(RowsCCI == 3)
              {              
              //-----------------------------   CCI    (42) ----------------------------------------
              //code = 0;
              if(val3_0 < 0      && val3_0 > -level && val3_1 <= -level )        code3 = 1;  //       
              if(val3_0 > 0      && val3_0 <  level && val3_1 <= 0 )             code3 = 2;  //            
              if(val3_0 > level  && val3_1 <= level )                            code3 = 3;  //      
              if(val3_0 > level  && val3_1 >  level )                            code3 = 4;  // 
              if(val3_0 < level  && val3_1 >= level )                            code3 = 5;  //      
              if(val3_0 < 0      && val3_1 >= 0 && val3_0 > - level)             code3 = 6;  //            
              if(val3_0 < -level && val3_1 >= -level )                           code3 = 7;  //       
              if(val3_0 < -level && val3_1 <= -level )                           code3 = 8;  //       
              if(val3_0 < level && val3_1 < level && val3_0 > 0 && val3_1 > 0)         code3 = 9;  //    
              if(val3_0 > -level && val3_1 > -level && val3_0 <= 0 && val3_1 <= 0)     code3 = 10; //    
 
              tt3 = " " + TfToString(CCI[i].timeFrame)  + " CCI_3(" + IntegerToString(CCI[i].period[2]) + ")= " +  DoubleToString(val3_0, 1) 
              + "\n" + CodeToText(code3, level);;
              DrawArrow(i, 3, code3, tt3);                                                        //  CCI
              } 
      }  
}
//==================================================================
//    CodeToText
//==================================================================
string CodeToText(int code,double level)
{
   string val = "";
 // return(val);
   if(code == 1)  val = "  -" + DoubleToString(level,0) + " ";
   if(code == 2)  val = "   ";
   if(code == 3)  val = "  " + DoubleToString(level,0) + " ";
   if(code == 4)  val = "  " + DoubleToString(level,0);
   if(code == 5)  val = "  " + DoubleToString(level,0) + " ";
   if(code == 6)  val = "   ";
   if(code == 7)  val = "  -" + DoubleToString(level,0) + " ";
   if(code == 8)  val = "  -" + DoubleToString(level,0);
   if(code == 9)  val = "   0";
   if(code == 10) val = "   0";
 
   return(val);
}
//==================================================================
//    DrawArrow
//==================================================================
void DrawArrow(int i, int cciNum, int code, string toolTip)
{
   string InpName = MyName + "ArrPicture_" + IntegerToString(i) + "_" + IntegerToString(cciNum) + "_code = " + IntegerToString(code);
   int x,y;  
   string InpFileOn, InpFileOff;  
   int width  = PicSize;
   int height = PicSize;
   int x_offset=0;
   int y_offset=0;
   bool InpState=false;                   //  /
   ENUM_BASE_CORNER  InpCorner=CORNER_RIGHT_UPPER;      //    
   ENUM_ANCHOR_POINT InpAnchor = ANCHOR_LEFT_UPPER;
   color             InpColor=clrRed;                  //    
   ENUM_LINE_STYLE   InpStyle=STYLE_SOLID;             //    
   int               InpPointWidth=1;                  //    
   bool              InpBack=false;                    //    
   bool              InpSelection= false;               //   
   bool              InpHidden=false;                   //    
   long              InpZOrder=0;                      //    
   int xSign=0, xOffset=0;
   int ySign=0, yOffset=0;
   ENUM_BASE_CORNER corner = Corner;
   
   if(corner == CORNER_LEFT_UPPER)     { xSign = 1;   ySign = 1;   xOffset = 0;       yOffset = 0;}
   if(corner == CORNER_RIGHT_UPPER)    { xSign = -1;  ySign = 1;   xOffset = TableW;  yOffset = 0; }
   if(corner == CORNER_LEFT_LOWER)     { xSign = 1;   ySign = -1;  xOffset = 0;       yOffset = TableH;}
   if(corner == CORNER_RIGHT_LOWER)    { xSign = -1;  ySign = -1;  xOffset = TableW;  yOffset = TableH;}

      x = BaseX + xOffset + xSign*gridStepX*(i+1);
      y = BaseY + yOffset + ySign*gridStepY*(cciNum);
      
      InpFileOn  = "\\Images\\" + "CCI_DB_" + IntegerToString(code) + ".bmp"; 
      InpFileOff = "\\Images\\" + "CCI_DB_" + IntegerToString(code) + ".bmp";                //    "\\Images\\dollar.bmp"
      
      double digS = MathMod(GetTickCount(),1000); //    ToolTip-      
      string strS = "_" + DoubleToString(digS,0);
      DelMyObj(InpName);
      InpName = InpName + strS;
      BitmapLabelCreate(0,InpName,0,x,y,InpFileOn,InpFileOff,width,height,x_offset,y_offset,InpState,
      corner,InpAnchor,InpColor,InpStyle,InpPointWidth,InpBack,InpSelection,InpHidden,InpZOrder, toolTip);
        
      ChartRedraw(0);
}

//==================================================================
//    GetInds
//==================================================================
void GetInds()
{
   int i;
      for(i=0; i<ArrSize; i++)    //   
      {
          
               CCI[i].val_1[0] = iCCI(NULL,CCI[i].timeFrame, CCI[i].period[0], PRICE_TYPICAL, 0);   
               CCI[i].val_1[1] = iCCI(NULL,CCI[i].timeFrame, CCI[i].period[0], PRICE_TYPICAL, 1);
               
               if(RowsCCI >= 2)
               {
               CCI[i].val_2[0] = iCCI(NULL,CCI[i].timeFrame, CCI[i].period[1], PRICE_TYPICAL, 0);   
               CCI[i].val_2[1] = iCCI(NULL,CCI[i].timeFrame, CCI[i].period[1], PRICE_TYPICAL, 1);
               }
               
               if(RowsCCI == 3)
               CCI[i].val_3[0] = iCCI(NULL,CCI[i].timeFrame, CCI[i].period[2], PRICE_TYPICAL, 0);   
               CCI[i].val_3[1] = iCCI(NULL,CCI[i].timeFrame, CCI[i].period[2], PRICE_TYPICAL, 1);
      }

}

//==================================================================
//    CreateHeaders
//==================================================================
void CreateHeaders(int gX,int gY)
{

   int i;
   //int x, y;
   string InpName;
   int InpX,InpY;
   string text;
   string InpFont = Font;
   int InpFontSize = FontSize;
   color InpColor = FontColor;
   double InpAngle = 0;
   ENUM_ANCHOR_POINT InpAnchor=ANCHOR_LEFT_UPPER; 
   bool              InpBack=false; 
   bool              InpSelection = false;
   bool              InpHidden=false;          //    
   long              InpZOrder=0;             //    
   
   int xSign=0, xOffset=0;
   int ySign=0, yOffset=0;
   ENUM_BASE_CORNER corner = Corner;
   
   if(corner == CORNER_LEFT_UPPER)     { xSign = 1;   ySign = 1;   xOffset = 0;       yOffset = 0;}
   if(corner == CORNER_RIGHT_UPPER)    { xSign = -1;  ySign = 1;   xOffset = TableW;  yOffset = 0; }
   if(corner == CORNER_LEFT_LOWER)     { xSign = 1;   ySign = -1;  xOffset = 0;       yOffset = TableH;}
   if(corner == CORNER_RIGHT_LOWER)    { xSign = -1;  ySign = -1;  xOffset = TableW;  yOffset = TableH;}
   
   //----------------   ---------------
   for(i = 0; i<ArrSize; i++)
   {
      InpName = MyName + "HeaderTF_" + IntegerToString(i) + "_" + IntegerToString(CCI[i].timeFrame);
      InpX = BaseX + xOffset + xSign*gridStepX*(i+1);
      InpY = BaseY + yOffset + ySign*5;      //  ySign*5 =       
      text = TfToString(CCI[i].timeFrame);
      
      ObjectDelete(0,InpName);
      LabelCreate(0,InpName,0,InpX,InpY, corner, text,InpFont,InpFontSize,
      InpColor,InpAngle,InpAnchor,InpBack,InpSelection,InpHidden,InpZOrder);
    
   }
  //----------------   ---------------
   for(i = 0; i<=RowsCCI-1; i++)
   {
      
      InpName = MyName + "HeaderPeriod_" + RowH[i];
      InpX = BaseX + xOffset + xSign*10;
      InpY = BaseY + yOffset + ySign*gridStepY*(i+1);
      text = RowH[i];
      ObjectDelete(0,InpName);
      LabelCreate(0,InpName,0,InpX,InpY, corner, text,InpFont,InpFontSize,
      InpColor,InpAngle,InpAnchor,InpBack,InpSelection,InpHidden,InpZOrder);
    
   }
   
    //----------------   --------------- 
  
 InpName = MyName + "ExitButton";

 int x_size = 15;
 int y_size = 15;

   if(corner == CORNER_LEFT_UPPER)     { xSign = 1;   ySign = 1;   xOffset = TableW - x_size -4;       yOffset = 4;}
   if(corner == CORNER_RIGHT_UPPER)    { xSign = -1;  ySign = 1;   xOffset = x_size + 4;            yOffset = 4; }
   if(corner == CORNER_LEFT_LOWER)     { xSign = 1;   ySign = -1;  xOffset = TableW - x_size -4;       yOffset = TableH-4;}
   if(corner == CORNER_RIGHT_LOWER)    { xSign = -1;  ySign = -1;  xOffset = x_size + 4;  yOffset = TableH-4;} 
 
 
 int x = BaseX + xOffset;
 int y = BaseY + yOffset;

 InpFont = "Arial Black";
 InpFontSize = 8;
 InpColor = clrBlack;
 color InpBackColor =  C'200,200,200';  //C'236,233,216'; //  
 color InpBorderColor = clrNONE;      //  
 bool InpState = false;
 InpBack=false;               //    
 InpSelection=false;          //   
 InpHidden=false;              //    
 InpZOrder=0; 
 ObjectDelete(0,InpName);
 
 ButtonCreate(0,InpName,0,x,y,x_size,y_size,corner,"x",InpFont,InpFontSize,
      InpColor,InpBackColor,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder);
}

//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
      bool res = false;
      bool state;
    if(id==CHARTEVENT_CLICK)
    {
      string name = MyName + "ExitButton";
      state = ObjectGetInteger(0,name, OBJPROP_STATE);
      if(state) 
        res=ChartIndicatorDelete(0,0,shortname);
    }
   
}

//==================================================================
//    TfToString
//==================================================================
string TfToString(sel_tf tf)
{
  string val = "";
  switch(tf)
  {
   case M1:
      val = "M1"; break;
   case M5:
      val = "M5"; break;
   case M15:
      val = "M15"; break;
   case M30:
      val = "M30"; break;
   case H1:
      val = "H1"; break;
   case H4:
      val = "H4"; break;
   case D1:
      val = "D1"; break;
   case W1:
      val = "W1"; break;
   case MN1:
      val = "MN1"; break;                     
   default:
      val = "";
      break;
  }
  return(val);
}

//==================================================================
//    InitCCIArray
//==================================================================
int InitCCIArray()
{
      if(TF1_V  == NO)
      {
         ArrSize = 0;
         ArrayResize(CCI, 0);
         return(ArrSize);   
      }
      
      CCI[0].period[0]    = TF1_P1;
      CCI[0].period[1]    = TF1_P2;
      CCI[0].period[2]    = TF1_P3;
      CCI[0].timeFrame    = TF1_V;
      CCI[0].level        = TF1_Level; 
      
      if(TF2_V  == NO)
      {
         ArrSize = 1;
         ArrayResize(CCI, 1);
         return(ArrSize); 
      }
      CCI[1].period[0]    = TF2_P1;
      CCI[1].period[1]    = TF2_P2;
      CCI[1].period[2]    = TF2_P3;
      CCI[1].timeFrame    = TF2_V;
      CCI[1].level        = TF2_Level;
     
      if(TF3_V  == NO)
      {
         ArrSize = 2;
         ArrayResize(CCI, 2);
         return(ArrSize); 
      }
      CCI[2].period[0]    = TF3_P1;
      CCI[2].period[1]    = TF3_P2;
      CCI[2].period[2]    = TF3_P3;
      CCI[2].timeFrame    = TF3_V;
      CCI[2].level        = TF3_Level;
      
      if(TF4_V  == NO)
      {
         ArrSize = 3;
         ArrayResize(CCI, 3);
         return(ArrSize);    
      }
      CCI[3].period[0]    = TF4_P1;
      CCI[3].period[1]    = TF4_P2;
      CCI[3].period[2]    = TF4_P3;
      CCI[3].timeFrame    = TF4_V;
      CCI[3].level        = TF4_Level;
      
      if(TF5_V  == NO)
      {
         ArrSize = 4;
         ArrayResize(CCI, 4);
         return(ArrSize);    
      }
      
      CCI[4].period[0]    = TF5_P1;
      CCI[4].period[1]    = TF5_P2;
      CCI[4].period[2]    = TF5_P3;
      CCI[4].timeFrame    = TF5_V;
      CCI[4].level        = TF5_Level;

       return(5);
}
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,               // ID 
                 const string            name="Label",             //  
                 const int               sub_window=0,             //  
                 const int               x=0,                      //    X
                 const int               y=0,                      //    Y
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                 const string            text="Label",             // 
                 const string            font="Arial",             // 
                 const int               font_size=10,             //  
                 const color             clr=clrRed,               // 
                 const double            angle=0.0,                //  
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //  
                 const bool              back=false,               //   
                 const bool              selection=false,          //   
                 const bool              hidden=true,              //    
                 const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ":     !   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }

//====================================================================
//     ,    
//   -  
//====================================================================
void DelMyObj(string myName)
{
int pos=-1;
string objName;
int    obj_total=ObjectsTotal();
         
      for(int i=obj_total-1;i>=0; i--)
      {
         objName = ObjectName(i);
         pos = StringFind(objName, myName, 0);
       if(pos!=-1) 
         {
            ObjectDelete(objName);
         }
      }
}

//+------------------------------------------------------------------+
//|   " "                               |
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,               // ID 
                       const string            name="BmpLabel",          //  
                       const int               sub_window=0,             //  
                       const int               x=0,                      //    X
                       const int               y=0,                      //    Y
                       const string            file_on="",               //    On
                       const string            file_off="",              //    Off
                       const int               width=0,                  // X-  
                       const int               height=0,                 // Y-  
                       const int               x_offset=10,              //     X
                       const int               y_offset=10,              //     Y
                       const bool              state=false,              // /
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //   
                       const color             clr=clrRed,               //    
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        //    
                       const int               point_width=1,            //   
                       const bool              back=false,               //   
                       const bool              selection=false,          //   
                       const bool              hidden=true,              //    
                       const long              z_order=0,                //    
                       const string            toolTip ="")              //  
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_BITMAP_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ":     \" \"!   = ",GetLastError());
      return(false);
     }
//---     On  Off
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,0,file_on))
     {
      Print(__FUNCTION__,
            ":       On!   = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,1,file_off))
     {
      Print(__FUNCTION__,
            ":       Off!   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//--- ,      (  )
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---        
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   
   ObjectSetString(chart_ID,name,OBJPROP_TOOLTIP,  "" ); //    . 
   //ChartRedraw(0);
   //ObjectSetString(chart_ID,name,OBJPROP_TOOLTIP, toolTip);
  // string s = ObjectGetString(0,name,OBJPROP_TOOLTIP);      // 
   
   ChartRedraw(0);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool RectLabelCreate(const long             chart_ID=0,               // ID 
                     const string           name="RectLabel",         //  
                     const int              sub_window=0,             //  
                     const int              x=0,                      //    X
                     const int              y=0,                      //    Y
                     const int              width=50,                 // 
                     const int              height=18,                // 
                     const color            back_clr=C'236,233,216',  //  
                     const ENUM_BORDER_TYPE border=BORDER_SUNKEN,     //  
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                     const color            clr=clrRed,               //    (Flat)
                     const ENUM_LINE_STYLE  style=STYLE_SOLID,        //   
                     const int              line_width=1,             //   
                     const bool             back=false,               //   
                     const bool             selection=false,          //   
                     const bool             hidden=true,              //    
                     const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ":     !   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---     (  Flat)
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
  
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,               // ID 
                  const string            name="Button",            //  
                  const int               sub_window=0,             //  
                  const int               x=0,                      //    X
                  const int               y=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                  const string            text="Button",            // 
                  const string            font="Arial",             // 
                  const int               font_size=10,             //  
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const bool              state=false,              // /
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ":    !   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
